/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

/*************  ˵    **************

̻STC32GתӰ壨бдԡ

CAN1(P5.0,P5.1)CAN2(P5.2,P5.3)ͨշӵͬһϡ

MCUÿӴCAN1CAN2һ֡ݡ

CAN1͵ııCAN2գCAN2͵ııCAN1ա

յһ׼֡, CAN֡Ϣͨ1(P3.0,P3.1)ӡ

Ĭϲ500KHz, û޸ġ

ע⣺CANͨŲǰҪR79R80Ͽ

ʱ, Ĭʱ 24MHz (û޸Ƶ).

******************************************/

#include "STC32G.h"  //ͷļ󣬲Ҫٰ"reg51.h"ͷļ
#include "stdio.h"
#include "intrins.h"

typedef 	unsigned char	u8;
typedef 	unsigned int	u16;
typedef 	unsigned long	u32;

#define MAIN_Fosc        24000000UL

/****************************** û ***********************************/

//SJW : ͬԾ  0~3
//SAM : ߵƽ  0:1; 1:3Σ߲100KHzΪ 0; 100KHzΪ 1
//TSG1: ͬ1       0~15
//TSG2: ͬ2       1~7 (TSG2 Ϊ0)
//BRP : ʷƵϵ    0~63
//CAN߲=Fclk/((1+(TSG1+1)+(TSG2+1))*(BRP+1)*2)
#define CANBRT(SJW, SAM, TSG1, TSG2, BRP)   (u16)(((SJW << 6) + BRP) + (((SAM << 7) + (TSG2 << 4) + TSG1) << 8))

#define CANBRT_10K          CANBRT(0, 1, 15, 6, 49)     //24000000/((1+16+7)*50*2)=10KHz
#define CANBRT_20K          CANBRT(0, 1, 13, 4, 29)     //24000000/((1+14+5)*30*2)=20KHz
#define CANBRT_40K          CANBRT(0, 1, 13, 4, 14)     //24000000/((1+14+5)*15*2)=40KHz
#define CANBRT_50K          CANBRT(0, 1, 5,  2, 23)     //24000000/((1+6+3)*24*2)=50KHz
#define CANBRT_80K          CANBRT(0, 1, 5,  2, 14)     //24000000/((1+6+3)*15*2)=80KHz
#define CANBRT_100K         CANBRT(0, 0, 5,  2, 11)     //24000000/((1+6+3)*12*2)=100KHz
#define CANBRT_125K         CANBRT(0, 0, 2,  1, 15)     //24000000/((1+3+2)*16*2)=125KHz
#define CANBRT_200K         CANBRT(0, 0, 5,  2, 5)      //24000000/((1+6+3)*6*2)=200KHz
#define CANBRT_250K         CANBRT(0, 0, 2,  1, 7)      //24000000/((1+3+2)*8*2)=250KHz
#define CANBRT_400K         CANBRT(0, 0, 5,  2, 2)      //24000000/((1+6+3)*3*2)=400KHz
#define CANBRT_500K         CANBRT(0, 0, 2,  1, 3)      //24000000/((1+3+2)*4*2)=500KHz
#define CANBRT_800K         CANBRT(0, 0, 1,  1, 2)      //24000000/((1+2+2)*3*2)=800KHz
#define CANBRT_1000K        CANBRT(0, 0, 2,  1, 1)      //24000000/((1+3+2)*2*2)=1000KHz

/*****************************************************************************/


/*************  س    **************/

#define Timer0_Reload   (65536UL -(MAIN_Fosc / 1000))       //Timer 0 жƵ, 1000/
#define Baudrate        115200UL
#define TM              (65536 -(MAIN_Fosc/Baudrate/4))

#define	STANDARD_FRAME   0     //֡ʽ׼֡
#define	EXTENDED_FRAME   1     //֡ʽչ֡

/*************  ر    **************/

typedef struct
{
	u8	DLC:4;          //ݳ, bit0~bit3
	u8	:2;             //, bit4~bit5
	u8	RTR:1;          //֡, bit6
	u8	FF:1;           //֡ʽ, bit7
	u32	ID;             //CAN ID
	u8	DataBuffer[8];  //ݻ
}CAN_DataDef;

CAN_DataDef CAN1_Tx;
CAN_DataDef CAN1_Rx[8];

CAN_DataDef CAN2_Tx;
CAN_DataDef CAN2_Rx[8];

bit B_1ms;          //1ms־
bit B_Can1Read;     //CAN յݱ־
bit B_Can2Read;     //CAN յݱ־
bit B_Can1Send;     //CAN ݱ־
bit B_Can2Send;     //CAN ݱ־
u16 msecond;

/*************  غ    **************/

void CANInit();
u8 CanReadReg(u8 addr);
u8 CanReadMsg(CAN_DataDef *CAN);
void CanSendMsg(CAN_DataDef *CAN);
void KeyResetScan(void);

/******************** ڴӡ ********************/
void UartInit(void)
{
	P_SW1 = (P_SW1 & 0x3f) | 0x00;    //USART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4
	SCON = (SCON & 0x3f) | 0x40; 
	T1x12 = 1;          //ʱʱ1Tģʽ
	S1BRT = 0;          //1ѡʱ1Ϊʷ
	TL1 = TM;
	TH1 = TM>>8;
	TR1 = 1;			//ʱ1ʼʱ
}

void UartPutc(unsigned char dat)
{
	SBUF = dat; 
	while(TI==0);
	TI = 0;
}

char putchar(char c)
{
	UartPutc(c);
	return c;
}

/*********************  *************************/
void main(void)
{
    u8 i,j,n,sr;

    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

    TMOD &= 0xf0;//16 bits timer auto-reload
    T0x12 = 1;  //Timer0 set as 1T
    TH0 = (u8)(Timer0_Reload / 256);
    TL0 = (u8)(Timer0_Reload % 256);
    ET0 = 1;    //Timer0 interrupt enable
    TR0 = 1;    //Tiner0 run

    CANInit();
    UartInit();
    EA = 1;     //ж

	//====ʼ=====
	CAN1_Tx.FF = STANDARD_FRAME;    //׼֡
	CAN1_Tx.RTR = 0;                //0֡1Զ֡
	CAN1_Tx.DLC = 0x08;             //ݳ
	CAN1_Tx.ID = 0x0567;            //CAN ID
	CAN1_Tx.DataBuffer[0] = 0x11;   //
	CAN1_Tx.DataBuffer[1] = 0x12;
	CAN1_Tx.DataBuffer[2] = 0x13;
	CAN1_Tx.DataBuffer[3] = 0x14;
	CAN1_Tx.DataBuffer[4] = 0x15;
	CAN1_Tx.DataBuffer[5] = 0x16;
	CAN1_Tx.DataBuffer[6] = 0x17;
	CAN1_Tx.DataBuffer[7] = 0x18;
	
	CAN2_Tx.FF = EXTENDED_FRAME;    //չ֡
	CAN2_Tx.RTR = 0;                //0֡1Զ֡
	CAN2_Tx.DLC = 0x08;             //ݳ
	CAN2_Tx.ID = 0x03456789;        //CAN ID
	CAN2_Tx.DataBuffer[0] = 0x21;   //
	CAN2_Tx.DataBuffer[1] = 0x22;
	CAN2_Tx.DataBuffer[2] = 0x23;
	CAN2_Tx.DataBuffer[3] = 0x24;
	CAN2_Tx.DataBuffer[4] = 0x25;
	CAN2_Tx.DataBuffer[5] = 0x26;
	CAN2_Tx.DataBuffer[6] = 0x27;
	CAN2_Tx.DataBuffer[7] = 0x28;

    while(1)
    {
        if(B_1ms)   //1ms
        {
            B_1ms = 0;
            
            if(++msecond >= 1000)   //1뵽
            {
                msecond = 0;

                //------------------CAN1ģ-----------------------
                CANSEL = 0;         //ѡCAN1ģ
                sr = CanReadReg(SR);

                if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
                {
                    CANAR = MR;
                    CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
                }
                else
                {
                    CanSendMsg(&CAN1_Tx);   //һ֡
                    CAN1_Tx.ID++;
                    CanSendMsg(&CAN1_Tx);   //һ֡
                }

                //------------------CAN2ģ-----------------------
                CANSEL = 1;         //ѡCAN2ģ
                sr = CanReadReg(SR);

                if(sr & 0x01)		//жǷ BS:BUS-OFF״̬
                {
                    CANAR = MR;
                    CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
                }
                else
                {
                    CanSendMsg(&CAN2_Tx);   //һ֡
                }
            }
        }

        if(B_Can1Read)
        {
            B_Can1Read = 0;
            
            CANSEL = 0;         //ѡCAN1ģ
            n = CanReadMsg(CAN1_Rx);    //ȡ
            if(n>0)
            {
                for(i=0;i<n;i++)
                {
//                    CanSendMsg(&CAN1_Rx[i]);  //CANԭ
                    printf("CAN1:ID=0x%08lX DLC=%d FF=%d RTR=%d ",CAN1_Rx[i].ID,CAN1_Rx[i].DLC,CAN1_Rx[i].FF,CAN1_Rx[i].RTR);   //ڴӡ֡Ϣ
                    for(j=0;j<CAN1_Rx[i].DLC;j++)
                    {
                        printf("0x%02X ",CAN1_Rx[i].DataBuffer[j]);    //Ӵյ
                    }
                    printf("\r\n");
                }
            }
        }

        if(B_Can2Read)
        {
            B_Can2Read = 0;
            
            CANSEL = 1;         //ѡCAN2ģ
            n = CanReadMsg(CAN2_Rx);    //ȡ
            if(n>0)
            {
                for(i=0;i<n;i++)
                {
//                    CanSendMsg(&CAN2_Rx[i]);  //CANԭ
                    printf("CAN2:ID=0x%08lX DLC=%d FF=%d RTR=%d ",CAN2_Rx[i].ID,CAN2_Rx[i].DLC,CAN2_Rx[i].FF,CAN2_Rx[i].RTR);   //ڴӡ֡Ϣ
                    for(j=0;j<CAN2_Rx[i].DLC;j++)
                    {
                        printf("0x%02X ",CAN2_Rx[i].DataBuffer[j]);    //Ӵյ
                    }
                    printf("\r\n");
                }
            }
        }
    }
}


/********************** Timer0 1msжϺ ************************/
void timer0 (void) interrupt 1
{
    B_1ms = 1;      //1ms־
}

//========================================================================
// : u8 ReadReg(u8 addr)
// : CANܼĴȡ
// : CANܼĴַ.
// : CANܼĴ.
// 汾: VER1.0
// : 2020-11-16
// ע: 
//========================================================================
u8 CanReadReg(u8 addr)
{
	u8 dat;
	CANAR = addr;
	dat = CANDR;
	return dat;
}

//========================================================================
// : void WriteReg(u8 addr, u8 dat)
// : CANܼĴú
// : CANܼĴַ, CANܼĴ.
// : none.
// 汾: VER1.0
// : 2020-11-16
// ע: 
//========================================================================
void CanWriteReg(u8 addr, u8 dat)
{
	CANAR = addr;
	CANDR = dat;
}

//========================================================================
// : void CanReadFifo(CAN_DataDef *CANx)
// : ȡCANݺ
// : *CANx: CAN߶ȡ.
// : none.
// 汾: VER2.0
// : 2023-01-31
// ע: 
//========================================================================
void CanReadFifo(CAN_DataDef *CAN)
{
    u8 i;
    u8 pdat[5];
    u8 RX_Index=0;

    pdat[0] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));

    if(pdat[0] & 0x80)  //жǱ׼֡չ֡
    {
        pdat[1] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));   //չ֡IDռ4ֽ
        pdat[2] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));
        pdat[3] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));
        pdat[4] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));
        CAN->ID = (((u32)pdat[1] << 24) + ((u32)pdat[2] << 16) + ((u32)pdat[3] << 8) + pdat[4]) >> 3;
    }
    else
    {
        pdat[1] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));   //׼֡IDռ2ֽ
        pdat[2] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));
        CAN->ID = ((pdat[1] << 8) + pdat[2]) >> 5;
    }
    
    CAN->FF = pdat[0] >> 7;     //֡ʽ
    CAN->RTR = pdat[0] >> 6;    //֡
    CAN->DLC = pdat[0];         //ݳ

    for(i=0;((i<CAN->DLC) && (i<8));i++)        //ȡݳΪlen಻8
    {
        CAN->DataBuffer[i] = CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));   //ȡЧ
    }
    while(RX_Index&3)   //жѶݳǷ4
    {
        CanReadReg((u8)(RX_BUF0 + (RX_Index++&3)));  //ȡݣһ֡ռ4ռ䣬㲹0
    }
}

//========================================================================
// : u8 CanReadMsg(void)
// : CANݺ
// : *CANx: CAN߶ȡ.
// : ֡.
// 汾: VER2.0
// : 2023-01-31
// ע: 
//========================================================================
u8 CanReadMsg(CAN_DataDef *CAN)
{
    u8 i;
    u8 n=0;

    do{
        CanReadFifo(&CAN[n++]);  //ȡջ
        i = CanReadReg(SR);
    }while(i&0x80);     //жϽջǷݣеĻȡ

    return n;   //֡
}

//========================================================================
// : void CanSendMsg(CAN_DataDef *CAN)
// : CANͱ׼֡
// : *CANx: CAN߷..
// : none.
// 汾: VER1.0
// : 2020-11-19
// ע: 
//========================================================================
void CanSendMsg(CAN_DataDef *CAN)
{
	u32 CanID;
    u8 RX_Index,i;

    if(CANSEL)  //жǷCAN2
    {
        while(B_Can2Send);  //ȴCAN2ϴη
    }
    else
    {
        while(B_Can1Send);  //ȴCAN1ϴη
    }

    if(CAN->FF)     //жǷչ֡
    {
        CanID = CAN->ID << 3;
        CanWriteReg(TX_BUF0,CAN->DLC|((u8)CAN->RTR<<6)|0x80);	//bit7: ׼֡(0)/չ֡(1), bit6: ֡(0)/Զ֡(1), bit3~bit0: ݳ(DLC)
        CanWriteReg(TX_BUF1,(u8)(CanID>>24));
        CanWriteReg(TX_BUF2,(u8)(CanID>>16));
        CanWriteReg(TX_BUF3,(u8)(CanID>>8));

        CanWriteReg(TX_BUF0,(u8)CanID);

        RX_Index = 1;
        for(i=0;((i<CAN->DLC) && (i<8));i++)        //ݳΪDLC಻8
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++&3)),CAN->DataBuffer[i]);   //дЧ
        }
        while(RX_Index&3)   //жѶݳǷ4
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++&3)),0x00);  //дݣһ֡ռ4ռ䣬㲹0
        }
    }
    else    //ͱ׼֡
    {
        CanID = (u16)(CAN->ID << 5);
        CanWriteReg(TX_BUF0,CAN->DLC|((u8)CAN->RTR<<6));  //bit7: ׼֡(0)/չ֡(1), bit6: ֡(0)/Զ֡(1), bit3~bit0: ݳ(DLC)
        CanWriteReg(TX_BUF1,(u8)(CanID>>8));
        CanWriteReg(TX_BUF2,(u8)CanID);

        RX_Index = 3;
        for(i=0;((i<CAN->DLC) && (i<8));i++)        //ݳΪDLC಻8
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++&3)),CAN->DataBuffer[i]);   //дЧ
        }
        while(RX_Index&3)   //жѶݳǷ4
        {
            CanWriteReg((u8)(TX_BUF0 + (RX_Index++&3)),0x00);  //дݣһ֡ռ4ռ䣬㲹0
        }
    }
	CanWriteReg(CMR ,0x04);		//һ֡
    
    if(CANSEL)  //жǷCAN2
    {
        B_Can2Send = 1;     //CAN2æ־
    }
    else
    {
        B_Can1Send = 1;     //CAN1æ־
    }
}

//========================================================================
// : void CanSetBaudrate(u16 brt)
// : CAN߲ú
// : brt: (λK).
// : none.
// 汾: VER1.0
// : 2023-5-24
// ע: 
//========================================================================
void CanSetBaudrate(u16 brt)
{
    switch(brt)
    {
        case 10:    brt = CANBRT_10K;   break;
        case 20:    brt = CANBRT_20K;   break;
        case 40:    brt = CANBRT_40K;   break;
        case 50:    brt = CANBRT_50K;   break;
        case 80:    brt = CANBRT_80K;   break;
        case 100:   brt = CANBRT_100K;  break;
        case 125:   brt = CANBRT_125K;  break;
        case 200:   brt = CANBRT_200K;  break;
        case 250:   brt = CANBRT_250K;  break;
        case 400:   brt = CANBRT_400K;  break;
        case 800:   brt = CANBRT_800K;  break;
        case 1000:  brt = CANBRT_1000K; break;
        default:
        case 500:   brt = CANBRT_500K;  break;
    }
    
//    CanWriteReg(MR, 0x04);          //ʹ Reset Mode
    CanWriteReg(BTR0, (u8)brt);
    CanWriteReg(BTR1, (u8)(brt >> 8));
//    CanWriteReg(MR, 0x00);          //˳ Reset Mode
}

//========================================================================
// : void CANInit()
// : CANʼ
// : none.
// : none.
// 汾: VER1.0
// : 2020-11-19
// ע: 
//========================================================================
void CANInit()
{
	//-------- CAN1 --------
	CANEN = 1;          //CAN1ģʹ
	CANSEL = 0;         //ѡCAN1ģ
	P_SW1 = (P_SW1 & ~(3<<4)) | (1<<4); //˿л(CAN_Rx,CAN_Tx) 0x00:P0.0,P0.1  0x10:P5.0,P5.1  0x20:P4.2,P4.5  0x30:P7.0,P7.1

	CanWriteReg(MR  ,0x04);		//ʹ Reset Mode
    CanSetBaudrate(500);		//òʣ500K
	
	CanWriteReg(ACR0,0x00);		//մĴ
	CanWriteReg(ACR1,0x00);
	CanWriteReg(ACR2,0x00);
	CanWriteReg(ACR3,0x00);
	CanWriteReg(AMR0,0xFF);		//μĴ
	CanWriteReg(AMR1,0xFF);
	CanWriteReg(AMR2,0xFF);
	CanWriteReg(AMR3,0xFF);

	CanWriteReg(IMR ,0xff);		//жϼĴ
	CanWriteReg(ISR ,0xff);		//жϱ־
	CanWriteReg(MR  ,0x00);		//˳ Reset Mode
	CANICR = 0x02;				//CANжʹ

	//-------- CAN2 --------
	CAN2EN = 1;         //CAN2ģʹ
	CANSEL = 1;         //ѡCAN2ģ
	P_SW3 = (P_SW3 & ~(3)) | (1);       //˿л(CAN_Rx,CAN_Tx) 0x00:P0.2,P0.3  0x01:P5.2,P5.3  0x02:P4.6,P4.7  0x03:P7.2,P7.3

	CanWriteReg(MR  ,0x04);		//ʹ Reset Mode
    CanSetBaudrate(500);		//òʣ500K

	CanWriteReg(ACR0,0x00);		//մĴ
	CanWriteReg(ACR1,0x00);
	CanWriteReg(ACR2,0x00);
	CanWriteReg(ACR3,0x00);
	CanWriteReg(AMR0,0xFF);		//μĴ
	CanWriteReg(AMR1,0xFF);
	CanWriteReg(AMR2,0xFF);
	CanWriteReg(AMR3,0xFF);

	CanWriteReg(IMR ,0xff);		//жϼĴ
	CanWriteReg(ISR ,0xff);		//жϱ־
	CanWriteReg(MR  ,0x00);		//˳ Reset Mode
	CANICR |= 0x20;				//CAN2жʹ
}

//========================================================================
// : void CANBUS1_Interrupt(void) interrupt CAN1_VECTOR
// : CANжϺ
// : none.
// : none.
// 汾: VER1.0
// : 2022-03-24
// ע: 
//========================================================================
void CANBUS1_Interrupt(void) interrupt CAN1_VECTOR
{
	u8 isr;
	u8 store;
	u8 arTemp;

	arTemp = CANAR;     //CANARֳ棬ѭд CANAR жϣж޸ CANAR 
	store = AUXR2;      //AUXR2ֳ
	
	AUXR2 &= ~0x08;		//ѡCAN1ģ
	isr = CanReadReg(ISR);

	if((isr & 0x04) == 0x04)  //TI
	{
		CANAR = ISR;
		CANDR = 0x04;    //CLR FLAG
		
		B_Can1Send = 0;
	}	
	if((isr & 0x08) == 0x08)  //RI
	{
		CANAR = ISR;
		CANDR = 0x08;    //CLR FLAG
	
		B_Can1Read = 1;
	}

	if((isr & 0x40) == 0x40)  //ALI
	{
		CANAR = ISR;
		CANDR = 0x40;    //CLR FLAG
	}	

	if((isr & 0x20) == 0x20)  //EWI
	{
		CANAR = MR;
		CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
		
		CANAR = ISR;
		CANDR = 0x20;    //CLR FLAG
	}	

	if((isr & 0x10) == 0x10)  //EPI
	{
		CANAR = ISR;
		CANDR = 0x10;    //CLR FLAG
	}	

	if((isr & 0x02) == 0x02)  //BEI
	{
		CANAR = ISR;
		CANDR = 0x02;    //CLR FLAG
	}	

	if((isr & 0x01) == 0x01)  //DOI
	{
		CANAR = ISR;
		CANDR = 0x01;    //CLR FLAG
	}	

	AUXR2 = store;     //AUXR2ֳָ
	CANAR = arTemp;    //CANARֳָ
}

//========================================================================
// : void CANBUS2_Interrupt(void) interrupt CAN2_VECTOR
// : CANжϺ
// : none.
// : none.
// 汾: VER1.0
// : 2020-11-19
// ע: 
//========================================================================
void CANBUS2_Interrupt(void) interrupt CAN2_VECTOR
{
	u8 isr;
	u8 store;
	u8 arTemp;

	arTemp = CANAR;     //CANARֳ棬ѭд CANAR жϣж޸ CANAR 
	store = AUXR2;      //AUXR2ֳ
	
	AUXR2 |= 0x08;		//ѡCAN2ģ
	isr = CanReadReg(ISR);

	if((isr & 0x04) == 0x04)  //TI
	{
		CANAR = ISR;
		CANDR = 0x04;    //CLR FLAG
		
		B_Can2Send = 0;
	}	
	if((isr & 0x08) == 0x08)  //RI
	{
		CANAR = ISR;
		CANDR = 0x08;    //CLR FLAG

		B_Can2Read = 1;
	}

	if((isr & 0x40) == 0x40)  //ALI
	{
		CANAR = ISR;
		CANDR = 0x40;    //CLR FLAG
	}	

	if((isr & 0x20) == 0x20)  //EWI
	{
		CANAR = MR;
		CANDR &= ~0x04;  // Reset Mode, BUS-OFF״̬˳
		
		CANAR = ISR;
		CANDR = 0x20;    //CLR FLAG
	}	

	if((isr & 0x10) == 0x10)  //EPI
	{
		CANAR = ISR;
		CANDR = 0x10;    //CLR FLAG
	}	

	if((isr & 0x02) == 0x02)  //BEI
	{
		CANAR = ISR;
		CANDR = 0x02;    //CLR FLAG
	}	

	if((isr & 0x01) == 0x01)  //DOI
	{
		CANAR = ISR;
		CANDR = 0x01;    //CLR FLAG
	}	

	AUXR2 = store;     //AUXR2ֳָ
	CANAR = arTemp;    //CANARֳָ
}

//========================================================================
// : void delay_ms(u8 ms)
// : ʱ
// : ms,Ҫʱms, ֻ֧1~255ms. ԶӦʱ.
// : none.
// 汾: VER1.0
// : 2013-4-1
// ע: 
//========================================================================
void delay_ms(u8 ms)
{
	u16 i;
	do
	{
		i = MAIN_Fosc / 6000;
		while(--i);
	}while(--ms);
}
